package kolokvijum;

import java.util.Arrays;
import java.util.List;

public class Programer extends Radnik {
	private String status;

	// kako bismo izbjegli if else odnosno kako bismo iskoristili contains
	// napomena da ova lista nije immutable sto potencijalno nije u redu
	private static final List<String> pozicije = Arrays.asList("Junior", "Middle", "Senior");

	public Programer() {
		setStatus("Junior"); // nije definisano sta raditi u ovom slucaju, ali kako je naglaseno da mora biti
								// 1 od 3, junior ce biti default. Manje vazno
	}

	public Programer(String ime, String prezime, double koeficijent, double osnovica, int staz, String status) {
		super(ime, prezime, koeficijent, osnovica, staz);
		this.status = status;
	}

	@Override
	public double plata() {
		return super.getOsnovica() * super.getKoeficijent() * (1 + super.getStaz() / 50.0) + dodatak();
	}

	public double dodatak() {
		// switch case nam nije bio ni potreban, ali smo ga demonstrirali
		// da su pozicije immutable mogli bismo koristiti pozicije.get(0) itd.
		switch (status) {
		case "Senior":
			return 300;
		case "Middle":
			return 150;
		default:
			return 0;
		}
	}

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		if (!pozicije.contains(status))
			throw new IllegalArgumentException("Neispravan status!");
		this.status = status;
	}

	@Override
	public String toString() {
		return "Programer " + super.toString() + ", status: " + status;
	}
	
}
